/*******************************************************************************
 *	@file			DLSound.h
 *	@brief			DirectX Library
 *
 *	@date			20-Jun-2010(Sun)
 ******************************************************************************/

#ifndef	__DLSOUND_INCLUDE__
#define	__DLSOUND_INCLUDE__

// vvZbT---------------------------------------------------------------
#include "DL.h"
#include <vector>

using namespace std;

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// 萔`---------------------------------------------------------------------
#pragma once

// 񋓌^`-------------------------------------------------------------------
/*******************************************************************************
 *	@enum		enumPlay		DLSound.h		"DLSound.h"
 *	@brief		Đ
 ******************************************************************************/
enum enumPlay
{
	enumPlay_Null			= 0,												//!< Ȃ
	enumPlay_Wait,																//!< ҋ@
	enumPlay_Play,																//!< Đ
	enumPlay_Loop,																//!< [vĐ
	enumPlay_Stop,																//!< ~
	enumPlay_Max,
};

// \̒`-------------------------------------------------------------------
/*******************************************************************************
 *	@struct		DSDEVICE		DLSound.h		"DLSound.h"
 *	@brief		foCX\
 ******************************************************************************/
struct DSDEVICE
{
	DSDEVICE( const LPGUID& lpGuid = NULL,
			  const LPCSTR& lpDesc = NULL,
			  const LPCSTR& lpModule = NULL )
		: m_lpGuid( lpGuid )
		, m_lpDesc( lpDesc )
		, m_lpModule( lpModule )
	{
	}

	//
	LPGUID					m_lpGuid;											//!< GUID
	LPCSTR					m_lpDesc;											//!< foCX
	LPCSTR					m_lpModule;											//!< W[
};

/*******************************************************************************
 *	@struct		DSPOS			DLSound.h		"DLSound.h"
 *	@brief		W\
 ******************************************************************************/
struct DSPOS
{
	DSPOS( const D3DVALUE& fX = 0.0f,
		   const D3DVALUE& fY = 0.0f,
		   const D3DVALUE& fZ = 0.0f )
		: m_fX( fX )
		, m_fY( fY )
		, m_fZ( fZ )
	{
	}

	//
	D3DVALUE				m_fX;												//!< wW
	D3DVALUE				m_fY;												//!< xW
	D3DVALUE				m_fZ;												//!< yW
};

/*******************************************************************************
 *	@struct		DSLISTENER		DLSound.h		"DLSound.h"
 *	@brief		Xi[\
 ******************************************************************************/
struct DSLISTENER
{
	DSLISTENER()
		: m_lpListener( NULL )
		, m_SPos()
		, m_SVel()
		, m_SFront()
		, m_STop()
		, m_fRolloff( 1.0f )
		, m_fDoppler( 0.0f )
	{
	}

	// 
	LPDIRECTSOUND3DLISTENER8	m_lpListener;									//!< Xi[
	DSPOS					m_SPos;												//!< ʒuW
	DSPOS					m_SVel;												//!< xW
	DSPOS					m_SFront;											//!< OxNg
	DSPOS					m_STop;												//!< xNg
	D3DVALUE				m_fRolloff;											//!< [EIt
	D3DVALUE				m_fDoppler;											//!< hbv[W
};

/*******************************************************************************
 *	@struct		DSBUFFER		DLSound.h		"DLSound.h"
 *	@brief		obt@\
 ******************************************************************************/
struct DSBUFFER
{
	DSBUFFER()
		: m_lpBuffer( NULL )
		, m_DSDesc()

		, m_lp3DBuffer( NULL )
		, m_SPos()
		, m_SVel()

		, m_szName()
	{
	}

	// f[^
	LPDIRECTSOUNDBUFFER8	m_lpBuffer;											//!< ZJ_Eobt@
	DSBUFFERDESC			m_DSDesc;											//!< obt@

	LPDIRECTSOUND3DBUFFER8	m_lp3DBuffer;										//!< Rcobt@
	DSPOS					m_SPos;												//!< ʒuW
	DSPOS					m_SVel;												//!< xW
	
	LPCSTR					m_szName;											//!< O
};

/*******************************************************************************
 *	@struct		DSOBJECT		DLSound.h		"DLSound.h"
 *	@brief		IuWFNg\
 ******************************************************************************/
struct DSOBJECT
{
	DSOBJECT()
		: m_bUsed( FALSE )
		, m_eObj( enumObject_Null )
		, m_nPrio( -1 )

		, m_nMatNum( -1 )

		, m_ePlay( enumPlay_Wait )

		, m_SPos()
		, m_SVel()
	{
	}

	// {
	BOOL					m_bUsed;											//!< gptO
	enumObject				m_eObj;												//!< IuWFNg
	int						m_nPrio;											//!< `vCIeB
	// f
	int						m_nMatNum;											//!< fޔԍ
	// 
	enumPlay				m_ePlay;											//!< Đ

	// Wݒ
	DSPOS					m_SPos;												//!< ʒuWiDSBUFFERƓj
	DSPOS					m_SVel;												//!< xWiDSBUFFERƓj
};

// NX-----------------------------------------------------------------------
/*******************************************************************************
 *	@class		CDLSound		DLSound.h			"DLSound.h"
 *	@brief		CDLSoundNX
 ******************************************************************************/
class CDLSound
{
// 萔`---------------------------------------------------------------------
private:
	static const int BUFFER_MAX		= 32;										//!< obt@
	static const int OBJECT_MAX		= 64;										//!< IuWFNg

protected:
public:

// o֐-------------------------------------------------------------------
private:
	static int ( CDLSound::*StepDel[ enumObject_SoundEnd - enumObject_SoundStart ] )( const int& nNum );
	static int ( CDLSound::*StepPlay[ enumPlay_Max ] )( const int& nNum );

	static BOOL CALLBACK DSEnumCallback( LPGUID lpGuid,
										 LPCSTR lpcstrDescription,
										 LPCSTR lpcstrModule,
										 LPVOID lpContext );					//!< foCX̗

	int CheckWave( const BYTE* byData );										//!< Wave

	// p[^ݒ
	int SetPosition( const DSPOS& SPos );										//!< ʒuWݒ
	int SetVelocity( const DSPOS& SVel );										//!< xWݒ
	int SetOrientation( const DSPOS& SFront,
						const DSPOS& STop );									//!< xNgݒ
	int SetRolloff( const D3DVALUE& fRolloff );									//!< [EItݒ
	int SetDoppler( const D3DVALUE& fDoppler );									//!< hbv[Wݒ

	int SetPosition( DSBUFFER& pBuf,
					 const DSPOS& SPos );										//!< ʒuWݒ
	int SetVelocity( DSBUFFER& pBuf,
					 const DSPOS& SVel );										//!< xWݒ

	// IuWFNg폜
	int DelBGM( const int& nNum );												//!< BGM폜
	int DelSE( const int& nNum );												//!< SE폜

	// IuWFNgs
	int ExecPlay( const int& nNum );											//!< Đ
	int ExecLoop( const int& nNum );											//!< [v
	int ExecStop( const int& nNum );											//!< ~

protected:
public:
	CDLSound( void );
	~CDLSound( void );

	int Init( const HWND& hWnd,
			  const BOOL& b3DSound = FALSE );									//!< 
	int End( void );															//!< I

	// ڊ
	DSBUFFER* GetBuffer( const int& nNum );										//!< obt@擾
	DSOBJECT* GetObject( const int& nNum );										//!< IuWFNg擾

	// fޓǂݍ
	int LoadWav( const int& nNum,
				 const LPCSTR& szName );										//!< Waveǂݍ

	// fމ
	int RemoveWav( const int& nNum );											//!< Wave
	int RemoveALL( void );														//!< fޑS

	// IuWFNgǉ
	int AddBGM( const int& nNum,
				const int& nPrio,
				const int& nMatNum,
				const enumPlay& ePlay,
				const DSPOS& SPos,
				const DSPOS& SVel );											//!< BGMǉ
	int AddSE( const int& nNum,
			   const int& nPrio,
			   const int& nMatNum,
			   const enumPlay& ePlay,
				const DSPOS& SPos,
				const DSPOS& SVel );											//!< SEǉ

	// IuWFNg폜
	int Del( const int& nNum );													//!< IuWFNg폜
	int DelALL( void );															//!< IuWFNgS폜

	// IuWFNgs
	int Play( const int& nNum );												//!< IuWFNgs

// oϐ-------------------------------------------------------------------
private:
	LPDIRECTSOUND8			m_lpSound;											//!< DirectSound IuWFNg
	DSBUFFERDESC			m_DSDesc;											//!< obt@
	LPDIRECTSOUNDBUFFER		m_lpPrimary;										//!< vC}Eobt@
	DSLISTENER				m_DSListener;										//!< Xi[\

	HWND					m_hWnd;												//!< EChEnh
	vector< DSDEVICE >		m_vDevice;											//!< foCX
	DSCAPS					m_DSCaps;											//!< foCX̔\
	DWORD					m_dwSpeaker;										//!< Xs[J[\
	BOOL					m_b3DSound;											//!< RcTEhgptO

	// IuWFNg
	DSBUFFER				m_DSBuf[ BUFFER_MAX ];								//!< obt@\
	DSOBJECT				m_DSObj[ OBJECT_MAX ];								//!< IuWFNg\

protected:
public:

};

// OO[oϐ---------------------------------------------------------

// O֐vg^Cv錾---------------------------------------------------

}	// namespace	DL

#ifdef __cplusplus
}
#endif

#endif	// __DLSOUND_INCLUDE__
